#!/usr/bin/awk -f

# genvel3_RTW_ASYMMETRIC.awk
# 
# Miroslav Broz (miroslav.broz@email.cz)

BEGIN{
  AU=149597870.e3;
  ms_auday=86400./AU;

  v_R_koef = ARGV[1];
  v_T_koef = ARGV[2];
  v_W_koef = ARGV[3];

  ARGV[1]=ARGV[2]=ARGV[3]="";

  OFMT=CONVFMT="%19.16E";
}
(FILENAME==ARGV[4]) && (NF>=3) && !/^#/{
  i++;
  v_R[i]=$1*ms_auday * v_R_koef;
  v_T[i]=$2*ms_auday * v_T_koef;
  v_W[i]=$3*ms_auday * v_W_koef;
}
(FILENAME==ARGV[5]) && !/^#/{
  j++;
  s[j]=$0;
}
END{
  n=i;
  m=j;

# no planets here
  N=0;
  for (j=1; j<=N; j++) {
    print s[j];
  }

  print n;
  split(s[N+2],R);
  split(s[N+3],V);

  normalize(R,n_R);
  cross_product(R,V,W);
  normalize(W,n_W)
  cross_product(n_W,n_R,n_T);

  for (i=1; i<=n; i++) {
    print s[N+2];
#    print s[N+3];	# dbg
    print " "  V[1] + v_R[i]*n_R[1] + v_T[i]*n_T[1] + v_W[i]*n_W[1],
               V[2] + v_R[i]*n_R[2] + v_T[i]*n_T[2] + v_W[i]*n_W[2],
               V[3] + v_R[i]*n_R[3] + v_T[i]*n_T[3] + v_W[i]*n_W[3];
    print "0";
    print "0.0";
  }
}


func normalize(r,n) {
  norm = sqrt(r[1]**2 + r[2]**2 + r[3]**2);
  n[1] = r[1]/norm;
  n[2] = r[2]/norm;
  n[3] = r[3]/norm;
  return;
}

func cross_product(a,b,c) {
  c[1] = a[2]*b[3]-a[3]*b[2];
  c[2] = a[3]*b[1]-a[1]*b[3];
  c[3] = a[1]*b[2]-a[2]*b[1];
  return;
}


